package java.io;

public class CharArrayWriter extends Writer {
   protected char[] buf;
   protected int count;

   public CharArrayWriter() {
      this(32);
   }

   public CharArrayWriter(int var1) {
      this.buf = new char[var1];
   }

   public void write(int var1) {
      Object var2 = super.lock;
      synchronized(var2){}

      try {
         int var4 = this.count + 1;
         if (var4 > this.buf.length) {
            char[] var5 = new char[Math.max(this.buf.length << 1, var4)];
            System.arraycopy(this.buf, 0, var5, 0, this.count);
            this.buf = var5;
         }

         this.buf[this.count] = (char)var1;
         this.count = var4;
      } catch (Throwable var7) {
         throw var7;
      }

   }

   public void write(char[] var1, int var2, int var3) {
      Object var4 = super.lock;
      synchronized(var4){}

      try {
         int var6 = this.count + var3;
         if (var6 > this.buf.length) {
            char[] var7 = new char[Math.max(this.buf.length << 1, var6)];
            System.arraycopy(this.buf, 0, var7, 0, this.count);
            this.buf = var7;
         }

         System.arraycopy(var1, var2, this.buf, this.count, var3);
         this.count = var6;
      } catch (Throwable var9) {
         throw var9;
      }

   }

   public void write(String var1, int var2, int var3) {
      Object var4 = super.lock;
      synchronized(var4){}

      try {
         int var6 = this.count + var3;
         if (var6 > this.buf.length) {
            char[] var7 = new char[Math.max(this.buf.length << 1, var6)];
            System.arraycopy(this.buf, 0, var7, 0, this.count);
            this.buf = var7;
         }

         var1.getChars(var2, var2 + var3, this.buf, this.count);
         this.count = var6;
      } catch (Throwable var9) {
         throw var9;
      }

   }

   public void writeTo(Writer var1) throws IOException {
      Object var2 = super.lock;
      synchronized(var2){}

      try {
         var1.write(this.buf, 0, this.count);
      } catch (Throwable var4) {
         throw var4;
      }

   }

   public void reset() {
      this.count = 0;
   }

   public char[] toCharArray() {
      Object var2 = super.lock;
      synchronized(var2){}

      char[] var1;
      try {
         char[] var4 = new char[this.count];
         System.arraycopy(this.buf, 0, var4, 0, this.count);
         var1 = var4;
      } catch (Throwable var6) {
         throw var6;
      }

      return var1;
   }

   public int size() {
      return this.count;
   }

   public String toString() {
      Object var2 = super.lock;
      synchronized(var2){}

      String var1;
      try {
         var1 = new String(this.toCharArray());
      } catch (Throwable var5) {
         throw var5;
      }

      return var1;
   }

   public void flush() {
   }

   public void close() {
   }
}
