package java.io;

import java.util.Vector;

public class ObjectInputStream extends InputStream implements ObjectInput, ObjectStreamConstants {
   // $FF: renamed from: in java.io.InputStream
   private InputStream field_0;
   private int count;
   private boolean blockDataMode;
   private byte[] buffer;
   private DataInputStream dis;
   private IOException abortIOException;
   private ClassNotFoundException abortClassNotFoundException;
   private Object currentObject;
   private ObjectStreamClass currentClassDesc;
   private Class currentClass;
   ObjectStreamClass[] classdesc;
   Class[] classes;
   int spClass;
   private Vector wireHandle2Object;
   private int nextWireOffset;
   private Vector callbacks;
   private int recursionDepth;
   private byte currCode;
   private boolean enableResolve;

   public ObjectInputStream(InputStream var1) throws IOException, StreamCorruptedException {
      this.field_0 = var1;
      this.dis = new DataInputStream(this);
      this.readStreamHeader();
      this.resetStream();
   }

   public final Object readObject() throws OptionalDataException, ClassNotFoundException, IOException {
      int var1;
      if (this.blockDataMode && (var1 = this.available()) > 0) {
         throw new OptionalDataException(var1);
      } else {
         this.peekCode();
         Object var2 = this.currentObject;
         ObjectStreamClass var3 = this.currentClassDesc;
         boolean var4 = this.setBlockData(false);
         ++this.recursionDepth;
         Object var5 = null;
         byte var6 = this.readCode();

         try {
            int var9 = -1;
            switch (var6) {
               case 112:
                  var5 = null;
                  break;
               case 113:
                  var9 = this.readInt() - 8257536;

                  try {
                     var5 = this.wireHandle2Object.elementAt(var9);
                     break;
                  } catch (ArrayIndexOutOfBoundsException var20) {
                     throw new StreamCorruptedException("Reference to object never serialized.");
                  }
               case 114:
                  var5 = this.inputClassDescriptor();
                  break;
               case 115:
                  var9 = this.inputObject();
                  var5 = this.currentObject;
                  if (this.enableResolve) {
                     var5 = this.resolveObject(var5);
                     this.wireHandle2Object.setElementAt(var5, var9);
                  }
                  break;
               case 116:
                  var5 = this.readUTF();
                  this.assignWireOffset(var5);
                  break;
               case 117:
                  var5 = this.inputArray();
                  break;
               case 118:
                  ObjectStreamClass var10 = (ObjectStreamClass)this.readObject();
                  if (var10 == null) {
                     throw new StreamCorruptedException("Class not in stream");
                  }

                  var5 = var10.forClass();
                  this.assignWireOffset(var5);
                  break;
               case 119:
               case 122:
                  if (var6 == 122) {
                     int var27 = this.field_0.read();
                     int var12 = this.field_0.read();
                     int var13 = this.field_0.read();
                     int var14 = this.field_0.read();
                     if ((var27 | var12 | var13 | var14) < 0) {
                        throw new StreamCorruptedException("EOF expecting count");
                     }

                     this.count = var27 << 24 | var12 << 16 | var13 << 8 | var14;
                     if (this.count < 0) {
                        throw new StreamCorruptedException("Negative block data size");
                     }
                  } else {
                     this.count = this.field_0.read();
                     if (this.count < 0) {
                        throw new StreamCorruptedException("EOF expecting count");
                     }
                  }

                  if (!var4) {
                     throw new StreamCorruptedException("Unexpected blockdata");
                  }

                  throw new OptionalDataException(this.count);
               case 120:
                  if (!var4) {
                     throw new StreamCorruptedException("Unexpected end of block data");
                  }

                  this.pushbackCode((byte)120);
                  this.count = -1;
                  throw new OptionalDataException(true);
               case 121:
               default:
                  throw new StreamCorruptedException("Unknown code in readObject " + var6);
               case 123:
                  this.resetStream();
                  IOException var11 = (IOException)this.readObject();
                  this.resetStream();
                  throw new WriteAbortedException("Writing aborted by exception", var11);
            }
         } catch (OptionalDataException var21) {
            throw var21;
         } catch (IOException var22) {
            if (this.abortIOException == null && this.abortClassNotFoundException == null) {
               this.abortIOException = var22;
            }
         } catch (ClassNotFoundException var23) {
            if (this.abortIOException == null && this.abortClassNotFoundException == null) {
               this.abortClassNotFoundException = var23;
            }
         } finally {
            --this.recursionDepth;
            this.currentObject = var2;
            this.currentClassDesc = var3;
            this.setBlockData(var4);
         }

         IOException var7 = this.abortIOException;
         if (this.recursionDepth == 0) {
            this.abortIOException = null;
         }

         if (var7 != null) {
            throw var7;
         } else {
            ClassNotFoundException var8 = this.abortClassNotFoundException;
            if (this.recursionDepth == 0) {
               this.abortClassNotFoundException = null;
            }

            if (var8 != null) {
               throw var8;
            } else {
               if (this.recursionDepth == 0) {
                  this.doValidations();
               }

               return var5;
            }
         }
      }
   }

   public final void defaultReadObject() throws IOException, ClassNotFoundException, NotActiveException {
      if (this.currentObject != null && this.currentClassDesc != null) {
         if (this.currentClassDesc.getFieldSequence() != null) {
            boolean var1 = this.setBlockData(false);
            this.inputClassFields(this.currentObject, this.currentClass, this.currentClassDesc.getFieldSequence());
            this.setBlockData(var1);
         }

      } else {
         throw new NotActiveException("defaultReadObject");
      }
   }

   public synchronized void registerValidation(ObjectInputValidation var1, int var2) throws NotActiveException, InvalidObjectException {
      if (this.recursionDepth == 0) {
         throw new NotActiveException("readObject not Active");
      } else if (var1 == null) {
         throw new InvalidObjectException("Null is not a valid callback object");
      } else {
         ValidationCallback var3 = new ValidationCallback(var1, var2);
         if (this.callbacks == null) {
            this.callbacks = new Vector(100, 100);
         }

         if (!this.callbacks.isEmpty() && ((ValidationCallback)this.callbacks.lastElement()).priority < var2) {
            int var4 = this.callbacks.size();

            for(int var5 = 0; var5 < var4; ++var5) {
               ValidationCallback var6 = (ValidationCallback)this.callbacks.elementAt(var5);
               if (var6.priority <= var2) {
                  this.callbacks.insertElementAt(var3, var5);
                  return;
               }
            }

         } else {
            this.callbacks.addElement(var3);
         }
      }
   }

   private void doValidations() throws InvalidObjectException {
      if (this.callbacks != null) {
         int var1 = this.callbacks.size();

         for(int var2 = 0; var2 < var1; ++var2) {
            ValidationCallback var3 = (ValidationCallback)this.callbacks.elementAt(var2);
            var3.callback.validateObject();
         }

      }
   }

   protected Class resolveClass(ObjectStreamClass var1) throws IOException, ClassNotFoundException {
      return this.loadClass0((Class)null, var1.getName());
   }

   private native Class loadClass0(Class var1, String var2) throws ClassNotFoundException;

   protected Object resolveObject(Object var1) throws IOException {
      return var1;
   }

   protected final boolean enableResolveObject(boolean var1) throws SecurityException {
      boolean var2 = this.enableResolve;
      if (var1) {
         ClassLoader var3 = this.getClass().getClassLoader();
         if (var3 == null) {
            this.enableResolve = true;
            return var2;
         } else {
            throw new SecurityException("Not trusted class");
         }
      } else {
         this.enableResolve = false;
         return var2;
      }
   }

   protected void readStreamHeader() throws IOException, StreamCorruptedException {
      short var1 = this.readShort();
      short var2 = this.readShort();
      if (var1 != -21267) {
         throw new StreamCorruptedException("InputStream does not contain a serialized object");
      } else if (var2 != 5) {
         throw new StreamCorruptedException("Version Mismatch, Expected " + 5 + " and got " + var2);
      }
   }

   private ObjectStreamClass inputClassDescriptor() throws IOException, InvalidClassException, ClassNotFoundException {
      String var2 = this.readUTF();
      long var3 = this.readLong();
      ObjectStreamClass var5 = new ObjectStreamClass(var2, var3);
      this.assignWireOffset(var5);
      var5.read(this);
      boolean var6 = this.setBlockData(true);
      Class var1 = this.resolveClass(var5);
      this.SkipToEndOfBlockData();
      this.setBlockData(var6);
      if (var1 == null) {
         throw new ClassNotFoundException(var5.getName());
      } else {
         var5.setClass(var1);
         ObjectStreamClass var7 = (ObjectStreamClass)this.readObject();
         var5.setSuperclass(var7);
         return var5;
      }
   }

   private Object inputArray() throws IOException, ClassNotFoundException {
      ObjectStreamClass var1 = (ObjectStreamClass)this.readObject();
      Class var2 = var1.forClass();
      int var3 = this.readInt();
      this.currentObject = allocateNewArray(var2, var3);
      this.assignWireOffset(this.currentObject);
      Class var5 = var2.getComponentType();
      if (var5.isPrimitive()) {
         if (this.buffer == null) {
            this.buffer = new byte[1024];
         }

         int var6 = this.buffer.length;
         int var7 = this.buffer.length;
         if (var5 == Boolean.TYPE) {
            boolean[] var8 = (boolean[])this.currentObject;

            for(int var4 = 0; var4 < var3; ++var4) {
               if (var6 >= var7) {
                  int var9 = Math.min(var3 - var4, var7);
                  this.readFully(this.buffer, 0, var9);
                  var6 = 0;
               }

               var8[var4] = this.buffer[var6] != 0;
               ++var6;
            }
         } else if (var5 == Byte.TYPE) {
            byte[] var19 = (byte[])this.currentObject;
            this.readFully(var19, 0, var3);
         } else if (var5 == Short.TYPE) {
            short[] var20 = (short[])this.currentObject;

            for(int var11 = 0; var11 < var3; ++var11) {
               if (var6 > var7 - 2) {
                  int var26 = Math.min((var3 - var11) * 2, var7);
                  this.readFully(this.buffer, 0, var26);
                  var6 = 0;
               }

               var20[var11] = (short)(((this.buffer[var6] & 255) << 8) + (this.buffer[var6 + 1] & 255));
               var6 += 2;
            }
         } else if (var5 == Integer.TYPE) {
            int[] var21 = (int[])this.currentObject;

            for(int var12 = 0; var12 < var3; ++var12) {
               if (var6 > var7 - 4) {
                  int var27 = Math.min((var3 - var12) * 4, var7);
                  this.readFully(this.buffer, 0, var27);
                  var6 = 0;
               }

               var21[var12] = ((this.buffer[var6] & 255) << 24) + ((this.buffer[var6 + 1] & 255) << 16) + ((this.buffer[var6 + 2] & 255) << 8) + (this.buffer[var6 + 3] & 255);
               var6 += 4;
            }
         } else if (var5 == Long.TYPE) {
            long[] var22 = (long[])this.currentObject;

            for(int var13 = 0; var13 < var3; ++var13) {
               if (var6 > var7 - 8) {
                  int var28 = Math.min((var3 - var13) * 8, var7);
                  this.readFully(this.buffer, 0, var28);
                  var6 = 0;
               }

               int var29 = ((this.buffer[var6] & 255) << 24) + ((this.buffer[var6 + 1] & 255) << 16) + ((this.buffer[var6 + 2] & 255) << 8) + (this.buffer[var6 + 3] & 255);
               int var10 = ((this.buffer[var6 + 4] & 255) << 24) + ((this.buffer[var6 + 5] & 255) << 16) + ((this.buffer[var6 + 6] & 255) << 8) + (this.buffer[var6 + 7] & 255);
               var22[var13] = ((long)var29 << 32) + ((long)var10 & 4294967295L);
               var6 += 8;
            }
         } else if (var5 == Float.TYPE) {
            float[] var23 = (float[])this.currentObject;

            for(int var14 = 0; var14 < var3; ++var14) {
               if (var6 > var7 - 4) {
                  int var30 = Math.min((var3 - var14) * 4, var7);
                  this.readFully(this.buffer, 0, var30);
                  var6 = 0;
               }

               int var31 = ((this.buffer[var6] & 255) << 24) + ((this.buffer[var6 + 1] & 255) << 16) + ((this.buffer[var6 + 2] & 255) << 8) + (this.buffer[var6 + 3] & 255);
               var6 += 4;
               var23[var14] = Float.intBitsToFloat(var31);
            }
         } else if (var5 == Double.TYPE) {
            double[] var24 = (double[])this.currentObject;

            for(int var15 = 0; var15 < var3; ++var15) {
               if (var6 > var7 - 8) {
                  int var32 = Math.min((var3 - var15) * 8, var7);
                  this.readFully(this.buffer, 0, var32);
                  var6 = 0;
               }

               int var33 = ((this.buffer[var6] & 255) << 24) + ((this.buffer[var6 + 1] & 255) << 16) + ((this.buffer[var6 + 2] & 255) << 8) + (this.buffer[var6 + 3] & 255);
               int var35 = ((this.buffer[var6 + 4] & 255) << 24) + ((this.buffer[var6 + 5] & 255) << 16) + ((this.buffer[var6 + 6] & 255) << 8) + (this.buffer[var6 + 7] & 255);
               var6 += 8;
               var24[var15] = Double.longBitsToDouble(((long)var33 << 32) + ((long)var35 & 4294967295L));
            }
         } else {
            if (var5 != Character.TYPE) {
               throw new InvalidClassException(var2.getName());
            }

            char[] var25 = (char[])this.currentObject;

            for(int var16 = 0; var16 < var3; ++var16) {
               if (var6 > var7 - 2) {
                  int var34 = Math.min((var3 - var16) * 2, var7);
                  this.readFully(this.buffer, 0, var34);
                  var6 = 0;
               }

               var25[var16] = (char)(((this.buffer[var6] & 255) << 8) + (this.buffer[var6 + 1] & 255));
               var6 += 2;
            }
         }
      } else {
         Object[] var18 = this.currentObject;

         for(int var17 = 0; var17 < var3; ++var17) {
            var18[var17] = this.readObject();
         }
      }

      return this.currentObject;
   }

   private int inputObject() throws IOException, ClassNotFoundException {
      int var1 = -1;
      this.currentClassDesc = (ObjectStreamClass)this.readObject();
      this.currentClass = this.currentClassDesc.forClass();
      if (this.currentClassDesc.isExternalizable()) {
         try {
            this.currentObject = allocateNewObject(this.currentClass, this.currentClass);
            var1 = this.assignWireOffset(this.currentObject);
            Externalizable var2 = (Externalizable)this.currentObject;
            var2.readExternal(this);
         } catch (IllegalAccessException var19) {
            throw new InvalidClassException(this.currentClass.getName(), "IllegalAccessException");
         } catch (InstantiationException var20) {
            throw new InvalidClassException(this.currentClass.getName(), "InstantiationException");
         }
      } else {
         ObjectStreamClass var23 = this.currentClassDesc;
         Class var3 = this.currentClass;
         int var4 = this.spClass;
         var23 = this.currentClassDesc;

         for(var3 = this.currentClass; var23 != null; var23 = var23.getSuperclass()) {
            Class var5 = var23.forClass();

            Class var6;
            for(var6 = var3; var6 != null && var5 != var6; var6 = var6.getSuperclass()) {
            }

            ++this.spClass;
            if (this.spClass >= this.classes.length) {
               int var7 = this.classes.length * 2;
               Class[] var8 = new Class[var7];
               ObjectStreamClass[] var9 = new ObjectStreamClass[var7];
               System.arraycopy(this.classes, 0, var8, 0, this.classes.length);
               System.arraycopy(this.classdesc, 0, var9, 0, this.classes.length);
               this.classes = var8;
               this.classdesc = var9;
            }

            if (var6 == null) {
               this.classdesc[this.spClass] = var23;
               this.classes[this.spClass] = null;
            } else {
               this.classdesc[this.spClass] = var23;
               this.classes[this.spClass] = var6;
               var3 = var6.getSuperclass();
            }
         }

         try {
            this.currentObject = allocateNewObject(this.currentClass, var3);
         } catch (NoSuchMethodError var16) {
            throw new InvalidClassException(var3.getName(), "NoSuchMethodError");
         } catch (IllegalAccessException var17) {
            throw new InvalidClassException(var3.getName(), "IllegalAccessException");
         } catch (InstantiationException var18) {
            throw new InvalidClassException(var3.getName(), "InstantiationException");
         }

         var1 = this.assignWireOffset(this.currentObject);

         try {
            for(this.spClass = this.spClass; this.spClass > var4; --this.spClass) {
               this.currentClassDesc = this.classdesc[this.spClass];
               this.currentClass = this.classes[this.spClass];
               if (this.classes[this.spClass] != null) {
                  this.setBlockData(true);
                  this.currentClassDesc.localClassDescriptor();
                  if (!this.invokeObjectReader(this.currentObject, this.currentClass)) {
                     this.defaultReadObject();
                  }
               } else if (this.currentClassDesc.getFieldSequence() != null) {
                  boolean var26 = this.setBlockData(false);
                  this.inputClassFields((Object)null, this.currentClass, this.currentClassDesc.getFieldSequence());
                  this.setBlockData(var26);
               }

               if (this.currentClassDesc.hasWriteObject()) {
                  this.SkipToEndOfBlockData();
               }

               this.setBlockData(false);
            }
         } finally {
            this.spClass = var4;
         }
      }

      return var1;
   }

   private void SkipToEndOfBlockData() throws IOException, ClassNotFoundException {
      while(this.peekCode() != 120) {
         try {
            this.readObject();
         } catch (OptionalDataException var2) {
            if (var2.length > 0) {
               ((InputStream)this).skip((long)var2.length);
            }
         }
      }

      this.readCode();
   }

   private void resetStream() throws IOException {
      this.wireHandle2Object = new Vector(100, 100);
      this.nextWireOffset = 0;
      this.classes = new Class[20];
      this.classdesc = new ObjectStreamClass[20];
      this.spClass = 0;
      this.setBlockData(true);
      this.callbacks = null;
   }

   private int assignWireOffset(Object var1) throws IOException {
      this.wireHandle2Object.addElement(var1);
      if (++this.nextWireOffset != this.wireHandle2Object.size()) {
         throw new StreamCorruptedException("Elements not assigned in order");
      } else {
         return this.nextWireOffset - 1;
      }
   }

   private byte peekCode() throws IOException, StreamCorruptedException {
      while(this.currCode == 0) {
         int var1 = this.field_0.read();
         if (var1 < 0) {
            throw new EOFException("Expecting code");
         }

         this.currCode = (byte)var1;
         if (this.currCode >= 112 && this.currCode <= 123) {
            if (this.currCode != 121) {
               continue;
            }

            if (this.recursionDepth == 0 && this.currentObject == null && this.currentClassDesc == null) {
               this.resetStream();
               this.currCode = 0;
               continue;
            }

            throw new StreamCorruptedException("Illegal stream state for reset");
         }

         throw new StreamCorruptedException("Type code out of range, is " + this.currCode);
      }

      return this.currCode;
   }

   private byte readCode() throws IOException, StreamCorruptedException {
      byte var1 = this.peekCode();
      this.currCode = 0;
      return var1;
   }

   private void pushbackCode(byte var1) {
      this.currCode = var1;
   }

   private boolean setBlockData(boolean var1) throws IOException {
      if (this.blockDataMode == var1) {
         return var1;
      } else if (this.blockDataMode && this.count > 0) {
         throw new StreamCorruptedException("Unread data");
      } else {
         this.count = var1 ? 0 : -1;
         this.blockDataMode = var1;
         return !var1;
      }
   }

   public int read() throws IOException {
      int var1;
      if (!this.blockDataMode) {
         var1 = this.field_0.read();
      } else {
         while(this.count == 0) {
            this.refill();
         }

         if (this.count < 0) {
            return -1;
         }

         var1 = this.field_0.read();
         if (var1 >= 0) {
            --this.count;
         }
      }

      return var1;
   }

   private void refill() throws IOException {
      this.count = -1;

      byte var1;
      try {
         var1 = this.peekCode();
      } catch (EOFException var7) {
         return;
      }

      if (var1 == 119) {
         var1 = this.readCode();
         int var10 = this.field_0.read();
         if (var10 < 0) {
            throw new StreamCorruptedException("EOF expecting count");
         } else {
            this.count = var10 & 255;
         }
      } else {
         if (var1 == 122) {
            var1 = this.readCode();
            int var2 = this.field_0.read();
            int var3 = this.field_0.read();
            int var4 = this.field_0.read();
            int var5 = this.field_0.read();
            if ((var2 | var3 | var4 | var5) < 0) {
               throw new StreamCorruptedException("EOF expecting count");
            }

            int var6 = var2 << 24 | var3 << 16 | var4 << 8 | var5;
            if (var6 < 0) {
               throw new StreamCorruptedException("Negative block data size");
            }

            this.count = var6;
         }

      }
   }

   public int read(byte[] var1, int var2, int var3) throws IOException {
      if (var3 < 0) {
         throw new IndexOutOfBoundsException();
      } else if (!this.blockDataMode) {
         return this.field_0.read(var1, var2, var3);
      } else {
         while(this.count == 0) {
            this.refill();
         }

         if (this.count < 0) {
            return -1;
         } else {
            int var5 = Math.min(var3, this.count);
            int var4 = this.field_0.read(var1, var2, var5);
            if (var4 > 0) {
               this.count -= var4;
            }

            return var4;
         }
      }
   }

   public int available() throws IOException {
      if (this.blockDataMode) {
         if (this.count == 0 && this.field_0.available() > 0) {
            this.refill();
         }

         return this.count >= 0 ? this.count : 0;
      } else {
         return 0;
      }
   }

   public void close() throws IOException {
      this.field_0.close();
   }

   public boolean readBoolean() throws IOException {
      return this.dis.readBoolean();
   }

   public byte readByte() throws IOException {
      return this.dis.readByte();
   }

   public int readUnsignedByte() throws IOException {
      return this.dis.readUnsignedByte();
   }

   public short readShort() throws IOException {
      return this.dis.readShort();
   }

   public int readUnsignedShort() throws IOException {
      return this.dis.readUnsignedShort();
   }

   public char readChar() throws IOException {
      return this.dis.readChar();
   }

   public int readInt() throws IOException {
      return this.dis.readInt();
   }

   public long readLong() throws IOException {
      return this.dis.readLong();
   }

   public float readFloat() throws IOException {
      return this.dis.readFloat();
   }

   public double readDouble() throws IOException {
      return this.dis.readDouble();
   }

   public void readFully(byte[] var1) throws IOException {
      this.dis.readFully(var1);
   }

   public void readFully(byte[] var1, int var2, int var3) throws IOException {
      if (var3 < 0) {
         throw new IndexOutOfBoundsException();
      } else {
         this.dis.readFully(var1, var2, var3);
      }
   }

   public int skipBytes(int var1) throws IOException {
      return this.dis.skipBytes(var1);
   }

   public String readLine() throws IOException {
      return this.dis.readLine();
   }

   public String readUTF() throws IOException {
      return this.dis.readUTF();
   }

   private native void inputClassFields(Object var1, Class var2, int[] var3) throws InvalidClassException, StreamCorruptedException, ClassNotFoundException, IOException;

   private static native Object allocateNewObject(Class var0, Class var1) throws InstantiationException, IllegalAccessException;

   private static native Object allocateNewArray(Class var0, int var1);

   private native boolean invokeObjectReader(Object var1, Class var2) throws InvalidClassException, StreamCorruptedException, ClassNotFoundException, IOException;
}
