package java.io;

public class PushbackReader extends FilterReader {
   private char[] buf;
   private int pos;

   public PushbackReader(Reader var1, int var2) {
      super(var1);
      this.buf = new char[var2];
      this.pos = var2;
   }

   public PushbackReader(Reader var1) {
      this(var1, 1);
   }

   private void ensureOpen() throws IOException {
      if (this.buf == null) {
         throw new IOException("Stream closed");
      }
   }

   public int read() throws IOException {
      Object var2 = super.lock;
      synchronized(var2){}

      int var1;
      try {
         this.ensureOpen();
         if (this.pos >= this.buf.length) {
            var1 = super.read();
            return var1;
         }

         var1 = this.buf[this.pos++];
      } catch (Throwable var5) {
         throw var5;
      }

      return var1;
   }

   public int read(char[] var1, int var2, int var3) throws IOException {
      Object var5 = super.lock;
      synchronized(var5){}

      int var4;
      try {
         this.ensureOpen();
         if (var3 <= 0) {
            var4 = 0;
            return var4;
         }

         int var7 = this.buf.length - this.pos;
         if (var7 > 0) {
            if (var3 < var7) {
               var7 = var3;
            }

            System.arraycopy(this.buf, this.pos, var1, var2, var7);
            this.pos += var7;
            var2 += var7;
            var3 -= var7;
         }

         if (var3 <= 0) {
            var4 = var7;
            return var4;
         }

         var3 = super.read(var1, var2, var3);
         if (var3 == -1) {
            var4 = var7 == 0 ? -1 : var7;
            return var4;
         }

         var4 = var7 + var3;
      } catch (Throwable var9) {
         throw var9;
      }

      return var4;
   }

   public void unread(int var1) throws IOException {
      Object var2 = super.lock;
      synchronized(var2){}

      try {
         this.ensureOpen();
         if (this.pos == 0) {
            throw new IOException("Pushback buffer overflow");
         }

         this.buf[--this.pos] = (char)var1;
      } catch (Throwable var4) {
         throw var4;
      }

   }

   public void unread(char[] var1, int var2, int var3) throws IOException {
      Object var4 = super.lock;
      synchronized(var4){}

      try {
         this.ensureOpen();
         if (var3 > this.pos) {
            throw new IOException("Pushback buffer overflow");
         }

         this.pos -= var3;
         System.arraycopy(var1, var2, this.buf, this.pos, var3);
      } catch (Throwable var6) {
         throw var6;
      }

   }

   public void unread(char[] var1) throws IOException {
      this.unread(var1, 0, var1.length);
   }

   public boolean ready() throws IOException {
      Object var2 = super.lock;
      synchronized(var2){}

      boolean var1;
      try {
         this.ensureOpen();
         var1 = this.pos < this.buf.length || super.ready();
      } catch (Throwable var5) {
         throw var5;
      }

      return var1;
   }

   public boolean markSupported() {
      return false;
   }

   public void close() throws IOException {
      super.close();
      this.buf = null;
   }
}
