package java.io;

public class StringReader extends Reader {
   private String str;
   private int length;
   private int next;
   private int mark;

   public StringReader(String var1) {
      this.str = var1;
      this.length = var1.length();
   }

   private void ensureOpen() throws IOException {
      if (this.str == null) {
         throw new IOException("Stream closed");
      }
   }

   public int read() throws IOException {
      Object var2 = super.lock;
      synchronized(var2){}

      int var1;
      try {
         this.ensureOpen();
         if (this.next < this.length) {
            var1 = this.str.charAt(this.next++);
            return var1;
         }

         var1 = -1;
      } catch (Throwable var5) {
         throw var5;
      }

      return var1;
   }

   public int read(char[] var1, int var2, int var3) throws IOException {
      Object var5 = super.lock;
      synchronized(var5){}

      int var4;
      try {
         this.ensureOpen();
         if (this.next < this.length) {
            int var7 = Math.min(this.length - this.next, var3);
            this.str.getChars(this.next, this.next + var7, var1, var2);
            this.next += var7;
            var4 = var7;
            return var4;
         }

         var4 = -1;
      } catch (Throwable var9) {
         throw var9;
      }

      return var4;
   }

   public long skip(long var1) throws IOException {
      Object var5 = super.lock;
      synchronized(var5){}

      long var3;
      try {
         this.ensureOpen();
         if (this.next < this.length) {
            long var7 = Math.min((long)(this.length - this.next), var1);
            this.next = (int)((long)this.next + var7);
            var3 = var7;
            return var3;
         }

         var3 = 0L;
      } catch (Throwable var10) {
         throw var10;
      }

      return var3;
   }

   public boolean ready() {
      return true;
   }

   public boolean markSupported() {
      return true;
   }

   public void mark(int var1) throws IOException {
      Object var2 = super.lock;
      synchronized(var2){}

      try {
         this.ensureOpen();
         this.mark = this.next;
      } catch (Throwable var4) {
         throw var4;
      }

   }

   public void reset() throws IOException {
      Object var1 = super.lock;
      synchronized(var1){}

      try {
         this.ensureOpen();
         this.next = this.mark;
      } catch (Throwable var3) {
         throw var3;
      }

   }

   public void close() {
      this.str = null;
   }
}
